/* main.c */
/* ITOGAWA's Slitherlink Solver */

/*
 'main'γˤ礭뤫⤷ʤ
*/

#define MAIN
#include "slink.h"

static int    value[CMAX + 1];
static sboard priority;
static carray done;

void init_state(void)
{
    geometry i, j;
    direction d;
    colour  c = 1, z;

    if (!(the = (state *)malloc(sizeof(state))))
    {
	fprintf(stderr, "Error: Heap overflowed!\n");
	exit(1);
    }

    the->index = the->Index + CMAX;
    the->pos   = the->Pos   + CMAX;

    for(i = 0; i <= y+3; i++)
    {
	the->color[i][  0] =
	the->color[i][x+3] = BLACK;
	the->activity[i][  0] =
	the->activity[i][x+3] = FALSE;
    }
    for(j = 1; j <= x+2; j++)
    {
	the->color[  0][j] =
        the->color[y+3][j] = BLACK;
	the->activity[  0][j] =
	the->activity[y+3][j] = FALSE;
    }

    for(i = 1; i <= y+2; i++)
    {
	the->color[i][  1] =
	the->color[i][x+2] = WHITE;
	sides[i][  1] =
	sides[i][x+2] = -1;
    }
    for(j = 2; j <= x+1; j++)
    {
	the->color[  1][j] =
        the->color[y+2][j] = WHITE;
	sides[  1][j] =
        sides[y+2][j] = -1;
    }

    for(i = 1; i <= y+2; i++)
        for(j = 1; j <= x+2; j++)
	    the->activity HERE = TRUE;

    for(i = 2; i <= y+1; i++)
        for(j = 2; j <= x+1; j++)
	{
	    the->color HERE = ++c;
	    the->index[ c] = 1;
	    the->index[-c] = 0;
	    the->pos[ c].y = i;
	    the->pos[ c].x = j;
	    the->pos[-c]   = empty;
	    priority HERE = sides HERE;
	    for(d=0; d <= 7; d++)
		priority HERE += sides DIRECTION(d);
	}

    the->index[WHITE] = (y+x+2)*2;
    the->pos[WHITE].y = 1;
    the->pos[WHITE].x = 1;

    the->index[BLACK] = 0;
    the->pos[BLACK] = empty;

    the->index[0] = 0;
    the->pos[0] = empty;
    priority[0][0] = 0;
    value[0] = 0;

    init_col_chkd();
    
    for(z=2; z <= cmax; z++)
    {
	the->top[z]    =
	the->bottom[z] = GETY(z);
	the->left[z]   =
	the->right[z]  = GETX(z);
	value[z] = 2;
    }
    the->top[BLACK]    =   2;
    the->bottom[BLACK] = y+1;
    the->left[BLACK]   =   2;
    the->right[BLACK]  = x+1;

    the->degfree = cmax-1;
    the->prev = NULL;
}    

void chkfirst(void)
{
    geometry i, j;

    for(i=2; i <= y+1; i++)
        for(j=2; j <= x+1; j++)
	{
	    switch (sides HERE)
	    {
	    case 0:  mark0(i, j); break;
	    case 3:  mark3(i, j); break;
	    default:              break;
	    }
	}
}

void chknumbers(void)
{
    geometry i, j, tmp;
    number f3;
    static geometry ys = 2, ye = 0, xs = 2, xe = 0;
    static number step = 1;

    if (!ye)
    {
	ye = y+1; xe = x+1;
    }

    do
    {
	f3 = the->degfree;
    
	step = -step;
	tmp = ys; ys = ye; ye = tmp;
	tmp = xs; xs = xe; xe = tmp;

	for(i = ys; i != (ye+step); i+=step)
	    for(j = xs; j != (xe+step); j+=step)
		if (the->activity HERE)
		{
		    switch (sides HERE)
		    {
		    case 1:  chk1(i, j); break;
		    case 2:  chk2(i, j); break;
		    case 3:  chk3(i, j); break;
		    default:             break;
		    }
		    chk_corner(i, j);
		    chk_around(i, j);
		}
	if (debug && (f3 - the->degfree))
	    fprintf (stderr, "chknumbers: reduced %5d color(s).\n",
		     f3 - the->degfree);
    }
    while (the->degfree < f3);
}

void chkcolors(void)
{
    colour c, z;
    geometry i, j, tmp;
    static geometry ys = 2, ye = 0, xs = 2, xe = 0;
    static number step = 1;

    if (!ye)
    {
	done[BLACK] = FALSE;
	ye = y+1; xe = x+1;
    }
    else
    {
	step = -step;
	tmp = ys; ys = ye; ye = tmp;
	tmp = xs; xs = xe; xe = tmp;
    }
    
    for (z =2; z <= cmax; z++)
	done[z] = TRUE;
    
    for(i = ys; i != (ye+step); i+=step)
	for(j = xs; j != (xe+step); j+=step)
	{
	    if (the->col_chkd HERE &&
		done[abs(c = the->color HERE)] &&
		activep(i, j, BLACK))
	    {
		done[abs(c)] = FALSE;
		     if (the->index[ c]) z =  c;
		else if (the->index[-c]) z = -c;
		else                     continue;
		if (debug >= 4)
		    fprintf (stderr, "=== Checking [%3d, %3d]...\n", i, j);
		if (!chkconj(z, WHITE))
		{		
		    recolor(z, BLACK);
		    chknumbers();
		}
		else if (!chkconj(z, BLACK))
		{
		    nochkconj = TRUE;
		    recolor(z, WHITE);
		    nochkconj = FALSE;
		    chknumbers();
		}
	    }
	}
}

boolean asmcond(colour old, colour new)
{
    int nold = (the->index[old] + the->index[-old]) * value[abs(old)],
        nnew = (the->index[new] + the->index[-new]) * value[abs(new)];

    return ((nnew > nold) ||
	    ((nnew == nold) && 
	     (priority[the->pos[new].y][the->pos[new].x] >
              priority[the->pos[old].y][the->pos[old].x]))); 
}

void assume(void)
{
    status result;
    colour c, asmclr = 0;

    flag = TRUE;

    for(c = 2; c <= cmax; c++)
	if (asmcond(asmclr, c)) asmclr = c;

    c = (rand() > (RAND_MAX/2)) ? asmclr : -asmclr;
    /*
       asmclr-asmclrΤɤ˲ꤷƤ褤
       'c = asmclr'ȤƤ⹽ʤäΤ
       Ǥɤˤ뤫ꤹ뤳Ȥˤ
       äơʬΥץबɬƱȤ
       ְä˹ԤΤ򸫤ΤϤĤ餤Ǥ硩
    */

    init_col_chkd();
    
    level++;
    if (debug >= 5)
	print_solution();
    if (debug)
	fprintf (stderr, ">>>>>> Level %d: in. (%5d, %6d)\n",
		 level, the->degfree, c);
    result = solve(c);
    level--;

    if((!opt_solveall) && result)
	longjmp(the->jb, SUCCESS);
    if (debug)
	fprintf (stderr, "<<<<<< Level %d: out. (%5d)\n",
		 level+1, the->degfree);
    recolor(c, WHITE);
    chknumbers();
    next_col_chkd();
    if (debug >= 6)
	print_solution();
}

status solve(colour c)
{
    status stop = 0, mode = 0;
    number f1, f2;

    if(!level) 
	init_state();
    else
	push_state();

    switch (setjmp(the->jb))
    {
    case 0:
        if(!level) 
	{
	    f1 = the->degfree;
	    chkfirst();
	    trim(WHITE);
	    trim(BLACK);
	    if (debug && (f1 - the->degfree))
		fprintf (stderr, "chkfirst: reduced %5d color(s).\n",
			 f1 - the->degfree);
	}
	else
	{
	    recolor(c, BLACK);
	    next_col_chkd();
	}
	chknumbers();
	
        while (the->degfree)
        {
            do
            {
	        f2 = the->degfree;
		trim(WHITE);
		trim(BLACK);
                chkcolors();
		next_col_chkd();
		if (opt_w && !mode && !(f2 - the->degfree))
		{
		    mode = 1;
		    f2 = cmax;
		    init_col_chkd();
		}
		else
		{		
		    mode = 0;
		    if (debug)
			fprintf (stderr,
				 "chkcolors: reduced %5d color(s).\n",
				 f2 - the->degfree);
		}
            }
            while (the->degfree < f2);

	    assume();
	}
	if (debug)
	    fprintf(stderr, "Level %d: failed.\n", level);
    case SUCCESS:
	stop = 1;
    default:
	value[abs(c)] += 5;
	break;
    }
    pop_state();
    return stop;
}

main(int argc, char *argv[])
{
    /* ν */
    srand(getpid());

    /* ޥɹԤβ */
    parse_commandline(argc, argv);

    read_problem(input);
    if (debug >= 4) print_problem();

    solve(0);

    if (opt_solveall)
    {
	fprintf(stderr, "I found %d solution(s).\n", solutions);
    }
    else if (!solutions)
    {
	fprintf(stderr, "Sorry, I couldn't solve the problem.\n");
    }
    exit(0);
}

