/* primitives.c */
/* ITOGAWA's Slitherlink Solver */

/* 
 ִŪʡ״ؿ򤳤˽᤿Ĥ
 main.cȤζϷ빽ۣ档
*/

#include "slink.h"

static position queue[(XMAX+2)*(YMAX+2)];
static sboard   chkd, fromp;

void push_state(void)
{
    state *tmp;
    
    if (!(tmp = (state *)malloc(sizeof(state))))
    {
	fprintf(stderr, "Error: Heap overflowed!\n");
	exit(1);
    }
    *(tmp) = *(the);
    tmp->index = tmp->Index + CMAX;
    tmp->pos   = tmp->Pos   + CMAX;
    tmp->prev  = the;
    the = tmp;    
}    

void pop_state(void)
{
    state *tmp;
    
    tmp = the;
    the = tmp->prev;
    free(tmp);
}    

void chknum(colour z)
{
    geometry i, j;
    direction d, diff, same;
    status s;
    colour c;

    for(i = the->top[z]; i <= the->bottom[z]; i++)
	for(j = the->left[z]; j <= the->right[z]; j++)
	    if (((s = sides HERE) > 0) && (abs(c = the->color HERE) == z)
		&& (the->activity HERE))
	    {
		diff = same = 0;
		for (d = 0; d <= 7; d+=2)
		{
		    if ((the->color DIRECTION(d)) == -c)
			diff++;
		    else if ((the->color DIRECTION(d)) == c)
			same++;
		}
		if ((diff > s) || (same > (4-s)))
		{
		    if (debug)
			fprintf(stderr,
				"!!! %6d[%4d,%4d]: Wrong number of edges!\n",
				sides HERE, i, j);
		    longjmp(the->jb, WRONGNUMBER);
		}
	    }
}

boolean activep(geometry i, geometry j, colour a)
/* a ǤʤФʤʤ */
{
    direction d;
    
    if  (abs(the->color HERE) == a)
	return TRUE;
    for(d = 0; d <= 7; d++)
	if  (abs(the->color DIRECTION(d)) == a)
		return TRUE;

    return FALSE;    
}

colour trimmed_color(geometry i, geometry j, colour c)
{
    colour z = the->color HERE;
    
    if ((c == z) && !(the->activity HERE))
	return -c;
    else 
	return z;
}

boolean can_trim(geometry i, geometry j, colour c)
{
    direction d, count = 0, count2 = 0;
    geometry p, q;

    for (d=0; d <= 7; d++)
    {
	p =i+dy[d]; q= j+dx[d];
	if (abs(trimmed_color(p, q, c)) != abs(c)) return FALSE;
	if (  trimmed_color(p, q, c) ==
	    -(trimmed_color(i+dy[(d+1)& 7], j+dx[(d+1)& 7], c)))
	    count++;
	if (!(d & 1) && trimmed_color(p, q, c) == c)
	    count2++;
    }
    return ((count == 2) && (count2 < 4));
}

void trim(colour c)
{
    geometry i, j, p, q;
    direction d;
    colour r;
    position *head, *tail;

    head = tail = queue;

    for(i = 0; i <= y+3; i++)
	for(j = 0; j <= x+3; j++)
	    chkd HERE = 0;
    
    if (the->index[c])
    {
	*head = the->pos[c];
	chkd[head->y][head->x] = 2;
    }
    else
        return;

    while (head <= tail)
    {
	i = head->y; j = head->x;
	if ((chkd HERE != 1) && (the->activity HERE))
	{
	    chkd HERE = 1;
	    if (the->color HERE == c)
	    {
		if (can_trim(i, j, c))
		{
		    if (debug >= 7)
			fprintf(stderr, "++++++ trimmed [%3d, %3d](%6d).\n",
				i, j, the->color HERE);
		    the->activity HERE = FALSE;
		    (the->index[c])--;
		}
		else
		{
		    the->pos[c].y = i;
		    the->pos[c].x = j;
		}
	    }
	    for (d=0; d <= 7; d+=2)
	    {
		p = i+dy[d]; q = j+dx[d];
		if (((r = trimmed_color(p, q, c)) != -c) &&
		    ((chkd[p][q] == 0) ||
		     ((chkd[p][q] == 1) && (!(the->activity HERE)) &&
		      (r == c))))
		{
		    chkd[p][q] = 2;
		    tail++;
		    tail->y = p;
		    tail->x = q;
		}
	    }	    
	}
	head++;
    }

    if (debug >= 2)
	fprintf(stderr, "*** trim(%6d): %5d\n", c, the->index[c]);
}

boolean chkconj_sub(colour from, colour to)
{
    geometry i, j, p, q;
    colour ato = abs(to);
    number count = the->index[to]+the->index[from];
    direction d;
    position *head, *tail;

    head = tail = queue;

    if (the->index[from])
	*head = the->pos[from];
    if (the->index[to])
	*head = the->pos[to];
    else
        return TRUE;

    for(i = 0; i <= y+3; i++)
	for(j = 0; j <= x+3; j++)
	    chkd HERE = ((the->color HERE + to) && the->activity HERE);

    chkd[head->y][head->x] = FALSE;

    while (count && head <= tail)
    {
	if (the->color[i = head->y][j = head->x] == to)
	{
#if 0
	    if (debug >= 8)
		fprintf(stderr, "------ chkconj: [%3d, %3d](%6d)\n", i, j, to);
#endif
	    count--;
	}
	for (d=0; d <= 7; d+=2)	
	    if (chkd[p = i+dy[d]][q = j+dx[d]])
	    {
		chkd[p][q] = FALSE;
		if (flag || activep(p, q, ato))
		{
		    tail++;
		    tail->y = p;
		    tail->x = q;
  	        }
	    }
	head++;
    }
    if (debug >= 5)
	fprintf(stderr, "--- chkconj(%6d && %6d): %5d cell(s) remain(s).\n",
		from, to, count);

    return (!count);
}

boolean chkconj(colour from, colour to)
{
    colour afrom = abs(from);
    geometry i, j,
             t = the->   top[afrom],
             b = the->bottom[afrom],
             l = the->  left[afrom],
             r = the-> right[afrom];
    boolean result;
    
    for(i = t; i <= b; i++)
        for(j = l; j <= r; j++)
	    if (fromp HERE = (abs(the->color HERE) == afrom))
		the->color HERE = (the->color HERE == from) ? to : -to;
    
    result = (chkconj_sub(from, to) && chkconj_sub(-from, -to));

    for(i = t; i <= b; i++)
        for(j = l; j <= r; j++)
	    if (fromp HERE)
		the->color HERE = (the->color HERE == to) ? from : -from;

    return result;
}

void chkconj2(colour from, colour to)
{
    if (!chkconj_sub(from, to) || !chkconj_sub(-from, -to))
    {
	if (debug)
	    fprintf(stderr, "!!! %6d ->%6d: Split!\n", from, to);
	longjmp(the->jb, SPLIT);
    }
}

void init_col_chkd(void)
{
    geometry i, j;

    for(i = 2; i <= y+1; i++)
	for(j = 2; j <= x+1; j++)
	    the->col_chkd HERE = 1;
}

void next_col_chkd(void)
{
    geometry i, j;

    for(i = 2; i <= y+1; i++)
        for(j = 2; j <= x+1; j++)
	    the->col_chkd HERE >>= 1;
}

void recolor(colour from, colour to)
{
    colour tmp, afrom, ato;
    geometry i, j, t, b, l, r;
    direction d;
    number tmp2;

    if (from == to) return;
    if (abs(from) < abs(to))
    {
	tmp = from; from = to; to = tmp;
    }    
    if (!(from + to))
    {
	if (debug)
	{
	    fprintf(stderr, 
		    "!!! Cannot recolor %6d[%3d, %3d]->%6d[%3d, %3d]!\n",
		    from, the->pos[from].y, the->pos[from].x,
		      to, the->pos[  to].y, the->pos[  to].x);
	}
	longjmp(the->jb, CANNOTRECOLOR);
    }

    afrom = abs(from); ato = abs(to);
    t = the->   top[afrom];
    b = the->bottom[afrom];
    l = the->  left[afrom];
    r = the-> right[afrom];

    for(i = t; i <= b; i++)
        for(j = l; j <= r; j++)
	    if (abs(the->color HERE) == afrom)
	    {
		the->color HERE = (the->color HERE == from) ? to : -to;

		the->col_chkd HERE |= 2;
		for (d=0; d <= 7; d++)
		    the->col_chkd DIRECTION(d) |= 2;
	    }
    
    the->index[ to] += the->index[ from];
    the->index[-to] += the->index[-from];
    the->index[from] = the->index[-from] = 0;

    if (the->pos[ from].y) the->pos[ to] = the->pos[ from];
    if (the->pos[-from].y) the->pos[-to] = the->pos[-from];
    the->pos[from] = the->pos[-from] = empty;

    if (the->   top[ato] > t) the->   top[ato] = t;
    if (the->bottom[ato] < b) the->bottom[ato] = b;
    if (the->  left[ato] > l) the->  left[ato] = l;
    if (the-> right[ato] < r) the-> right[ato] = r;

    if (flag)
    {
	if (!nochkconj)
	    chkconj2(from, to);
	chknum(ato);
    }
    
    (the->degfree)--;
    if (debug >= 3)
    {
	for(tmp2 = level; tmp2; tmp2--)
	    fprintf (stderr, "#");
	fprintf (stderr, " %5d: %6d -> %6d[%3d, %3d](%5d)\n",
		 the->degfree, from, to, 
		 the->pos[to].y, the->pos[to].x, the->index[to]);
    }
    if (debug >= 6 || the->degfree == 0) print_solution();
    if (debug >= 7) print_activity();
}

