/* slink.h */
/* ITOGAWA's Slitherlink Solver */

/* ɬפheader fileinclude */
#include <stdio.h>
#include <setjmp.h>
#include <stdlib.h>
#include <math.h>
#include <unistd.h>

/* ǰΤRAND_MAX */
#ifndef RAND_MAX
#define RAND_MAX 0x7fffffff
#endif

/* ʥޥ */
#ifdef MAIN
#define EXTERN 
#define VALUE(value) = value
#else
#define EXTERN extern
#define VALUE(value) 
#endif

/*  */
#define TRUE  1
#define FALSE 0

#define SUCCESS        1
#define SPLIT          2
#define CANNOTRECOLOR  3
#define WRONGNUMBER    4

#define BLANK -1

#define WHITE (-1)
#define BLACK ( 1)

#define YMAX 178
#define XMAX 128 
/*
 ԤϡǥӥΥ(^^)
 Τޤޤѥ򿩤Τǡ
 YMAXڤXMAXͤϡ
 פ˱Ŭ˾⤷ʤ
*/
#define CMAX (YMAX*XMAX + 1)

/*  */
typedef char            boolean;
typedef unsigned char direction;
typedef char             status;
typedef unsigned char  geometry;
typedef short            colour;
typedef short            number;
typedef struct POSITION
{
    geometry y;
    geometry x;
}
position;

typedef colour   cboard[YMAX+4][XMAX+4];
typedef status   sboard[YMAX+4][XMAX+4];
typedef number   narray[CMAX*2 + 1];
typedef status   sarray[CMAX*2 + 1];
typedef position parray[CMAX*2 + 1];
typedef geometry garray[CMAX   + 1];
typedef colour   carray[CMAX   + 1];

typedef struct STATE
{
    sboard                   activity;
    cboard                      color;
    narray                      Index;
    number                     *index;
    parray                        Pos;
    position                     *pos;
    number                    degfree;
    garray   top, bottom, left, right;
    sboard                   col_chkd;
    jmp_buf                        jb;
    struct STATE                *prev;
}
state;

/* ѿ */
EXTERN geometry  x VALUE(1);
EXTERN geometry  y VALUE(1);
EXTERN colour cmax VALUE(0);

EXTERN state *the VALUE(NULL);
/*
 ˤ˻ȤΤǡǤܾˤʤʤ
*/

EXTERN sboard  sides;

EXTERN number  level     VALUE(0);
EXTERN int     solutions VALUE(0);
EXTERN boolean flag      VALUE(FALSE);
EXTERN boolean nochkconj VALUE(FALSE);

/*
 ˤϡۤɤΡʥޥפ
 ͭǤϤʤ()
*/
#ifdef MAIN
char        dy[8] = {0, 1, 1, 1, 0,-1,-1,-1};
char        dx[8] = {1, 1, 0,-1,-1,-1, 0, 1};
char knight_dy[8] = {1, 2, 2, 1,-1,-2,-2,-1};
char knight_dx[8] = {2, 1,-1,-2,-2,-1, 1, 2};
position empty    = {0, 0};
#else
extern char        dy[8];
extern char        dx[8];
extern char knight_dy[8];
extern char knight_dx[8];
extern position empty   ;
#endif

/* ޥ */
#define GETY(c) ((((c)-2) / x)+2)
#define GETX(c) ((((c)-2) % x)+2)

#define        DIRECTION(d) [i+       dy[(d)&7]  ][j+       dx[(d)&7]  ]
#define   OVER_DIRECTION(d) [i+       dy[(d)&7]*2][j+       dx[(d)&7]*2]
#define KNIGHT_DIRECTION(d) [i+knight_dy[(d)&7]  ][j+knight_dx[(d)&7]  ]

#define HERE [i][j]

/** ؿ **/

/* in primitives.c */
void    push_state   (void);
void    pop_state    (void);
void    chknum       (colour z);
boolean activep(geometry i, geometry j, colour a);
colour  trimmed_color(geometry i, geometry j, colour c);
boolean can_trim     (geometry i, geometry j, colour c);
void    trim         (colour c);
boolean chkconj_sub  (colour from, colour to);
boolean chkconj      (colour from, colour to);
void    chkconj2     (colour from, colour to);
void    init_col_chkd(void);
void    next_col_chkd(void);
void    recolor      (colour from, colour to);

/* in numrules.c */
void mark0     (geometry i, geometry j);
void mark3     (geometry i, geometry j);
void chk_corner(geometry i, geometry j);
void chk_around(geometry i, geometry j);
void chk1      (geometry i, geometry j);
void chk2      (geometry i, geometry j);
void chk3      (geometry i, geometry j);

/* in interfaces.c */
void parse_commandline   (int argc, char *argv[]);
void read_problem        (FILE* input);
void print_problem       (void);
void print_activity      (void);
void print_solution      (void);
void print_solution_block(FILE* output);
void print_solution_line (FILE* output);
void print_solution_grph (void);

/* in main.c */
void  init_state(void);
void    chkfirst(void);
void  chknumbers(void);
void   chkcolors(void);
boolean  asmcond(colour old, colour new);
void      assume(void);
status     solve(colour c);

/* and main(int argc, char *argv[]);. */

/* ޥɹԲϤ˴Ϣѿ */
EXTERN status opt_solveall VALUE(FALSE);
EXTERN status opt_grphout  VALUE(FALSE);
EXTERN status opt_w        VALUE(FALSE);
EXTERN FILE*  input        VALUE(stdin);
EXTERN char   debug        VALUE(0);
EXTERN void (*print_solution_hook)(FILE *) VALUE(print_solution_line);
EXTERN char*  problem      VALUE(NULL);

/* end of slink.h */

